// RFC 6120
const saslXmlns = 'urn:ietf:params:xml:ns:xmpp-sasl';
const stanzaXmlns = 'jabber:client';
const streamXmlns = 'http://etherx.jabber.org/streams';
const bindXmlns = 'urn:ietf:params:xml:ns:xmpp-bind';
const startTlsXmlns = 'urn:ietf:params:xml:ns:xmpp-tls';
const fullStanzaXmlns = 'urn:ietf:params:xml:ns:xmpp-stanzas';

// RFC 6121
const rosterXmlns = 'jabber:iq:roster';
const rosterVersioningXmlns = 'urn:xmpp:features:rosterver';

// XEP-0004
const dataFormsXmlns = 'jabber:x:data';

// XEP-0030
const discoInfoXmlns = 'http://jabber.org/protocol/disco#info';
const discoItemsXmlns = 'http://jabber.org/protocol/disco#items';

// XEP-0033
const extendedAddressingXmlns = 'http://jabber.org/protocol/address';

// XEP-0054
const vCardTempXmlns = 'vcard-temp';
const vCardTempUpdate = 'vcard-temp:x:update';

// XEP-0060
const pubsubXmlns = 'http://jabber.org/protocol/pubsub';
const pubsubEventXmlns = 'http://jabber.org/protocol/pubsub#event';
const pubsubOwnerXmlns = 'http://jabber.org/protocol/pubsub#owner';
const pubsubPublishOptionsXmlns = 'http://jabber.org/protocol/pubsub#publish-options';
const pubsubNodeConfigMax = 'http://jabber.org/protocol/pubsub#config-node-max';
const pubsubNodeConfigMultiItems = 'http://jabber.org/protocol/pubsub#multi-items';

// XEP-0066
const oobDataXmlns = 'jabber:x:oob';

// XEP-0084
const userAvatarDataXmlns = 'urn:xmpp:avatar:data';
const userAvatarMetadataXmlns = 'urn:xmpp:avatar:metadata';

// XEP-0085
const chatStateXmlns = 'http://jabber.org/protocol/chatstates';

// XEP-0115
const capsXmlns = 'http://jabber.org/protocol/caps';

// XEP-0184
const deliveryXmlns = 'urn:xmpp:receipts';

// XEP-0191
const blockingXmlns = 'urn:xmpp:blocking';

// XEP-0198
const smXmlns = 'urn:xmpp:sm:3';

// XEP-0203
const delayedDeliveryXmlns = 'urn:xmpp:delay';

// XEP-0234
const jingleFileTransferXmlns = 'urn:xmpp:jingle:apps:file-transfer:5';

// XEP-0280
const carbonsXmlns = 'urn:xmpp:carbons:2';

// XEP-0297
const forwardedXmlns = 'urn:xmpp:forward:0';

// XEP-0300
const hashXmlns = 'urn:xmpp:hashes:2';
const hashFunctionNameBaseXmlns = 'urn:xmpp:hash-function-text-names';
const hashSha256 = 'sha-256';
const hashSha512 = 'sha-512';
const hashSha3256 = 'sha3-256';
const hashSha3512 = 'sha3-512';
const hashBlake2b256 = 'blake2b-256';
const hashBlake2b512 = 'blake2b-512';

// XEP-0308
const lmcXmlns = 'urn:xmpp:message-correct:0';

// XEP-0333
const chatMarkersXmlns = 'urn:xmpp:chat-markers:0';

// XEP-0334
const messageProcessingHintsXmlns = 'urn:xmpp:hints';

// XEP-0352
const csiXmlns = 'urn:xmpp:csi:0';

// XEP-0359
const stableIdXmlns = 'urn:xmpp:sid:0';

// XEP-0363
const httpFileUploadXmlns = 'urn:xmpp:http:upload:0';

// XEP-0372
const referenceXmlns = 'urn:xmpp:reference:0';

// XEP-380
const emeXmlns = 'urn:xmpp:eme:0';
const emeOtr = 'urn:xmpp:otr:0';
const emeLegacyOpenPGP = 'jabber:x:encrypted';
const emeOpenPGP = 'urn:xmpp:openpgp:0';
const emeOmemo = 'eu.siacs.conversations.axolotl';
const emeOmemo1 = 'urn:xmpp:omemo:1';
const emeOmemo2 = 'urn:xmpp:omemo:2';

// XEP-0384
const omemoXmlns = 'urn:xmpp:omemo:2';
const omemoDevicesXmlns = 'urn:xmpp:omemo:2:devices';
const omemoBundlesXmlns = 'urn:xmpp:omemo:2:bundles';

// XEP-0385
const simsXmlns = 'urn:xmpp:sims:1';

// XEP-0420
const sceXmlns = 'urn:xmpp:sce:1';

// XEP-0422
const fasteningXmlns = 'urn:xmpp:fasten:0';

// XEP-0424
const messageRetractionXmlns = 'urn:xmpp:message-retract:0';

// XEP-0428
const fallbackIndicationXmlns = 'urn:xmpp:fallback:0';

// XEP-0444
const messageReactionsXmlns = 'urn:xmpp:reactions:0';

// XEP-0446
const fileMetadataXmlns = 'urn:xmpp:file:metadata:0';

// XEP-0447
const sfsXmlns = 'urn:xmpp:sfs:0';

// XEP-0448
const sfsEncryptionXmlns = 'urn:xmpp:esfs:0';
const sfsEncryptionAes128GcmNoPaddingXmlns = 'urn:xmpp:ciphers:aes-128-gcm-nopadding:0';
const sfsEncryptionAes256GcmNoPaddingXmlns = 'urn:xmpp:ciphers:aes-256-gcm-nopadding:0';
const sfsEncryptionAes256CbcPkcs7Xmlns = 'urn:xmpp:ciphers:aes-256-cbc-pkcs7:0';

// XEP-0449
const stickersXmlns = 'urn:xmpp:stickers:0';

// XEP-0461
const replyXmlns = 'urn:xmpp:reply:0';
const fallbackXmlns = 'urn:xmpp:feature-fallback:0';

// ???
const urlDataXmlns = 'http://jabber.org/protocol/url-data';
